#include <errno.h>
#include <tiuser.h>
#include <ntliapp.h>
#include <sys/byteorder.h>
#include <string.h>
#include <fcntl.h>

int endpoint = (-1);
  struct t_unitdata* tudata = 0;

static void cleanup(void) {
  t_free((void*)tudata, T_UNITDATA);
  t_close(endpoint);
}


int main(int argc, char* argv[]) {
  char myname[49];
  struct t_bind* tbind = 0;

  GetFileServerName(0, myname);
  myname[17] = 0;
  memset(myname + strlen(myname), ' ', 16 - strlen(myname));

  endpoint = t_open("/dev/netbdg", O_RDWR, 0);
  if (endpoint == -1) {
    t_error("opening endpoint");
    goto error1;
  }

  atexit(cleanup);

  tbind = (struct t_bind*)t_alloc(endpoint, T_BIND, T_ADDR);
  if (!tbind) {
    t_error("allocating tbind");
    goto error1;
  }
  memset(tbind->addr.buf, 0, tbind->addr.maxlen);
  tbind->addr.len = sizeof(IPX_ADDR);
  *(unsigned short*)((IPX_ADDR*)tbind->addr.buf)->ipxa_socket = htons(0x551);

  if (t_bind(endpoint, tbind, tbind)) {
    t_error("binding endpoint");
    goto error2;
  }
  t_free((void*)tbind, T_BIND);
  tbind = 0;

  tudata = (struct t_unitdata*)t_alloc(endpoint, T_UNITDATA, T_ALL);
  if (!tudata) {
    t_error("allocating tudata");
    goto error1;
  }

  for (;;) {
    int flags = 0;
    if (t_rcvudata(endpoint, tudata, &flags)) {
      t_error("receiving");
      goto error1;
    }
    if (tudata->udata.len < 68 ||
	(unsigned char)tudata->udata.buf[32] != 0xf3 ||
	strncmp(tudata->udata.buf+36, myname, 16) != ESUCCESS)
      continue;
    memset(tudata->udata.buf, 0, 32);
    tudata->udata.buf[32] = 0xf4;
    if (t_sndudata(endpoint, tudata)) {
      t_error("sending");
      goto error1;
    }
  }

 error2:
  t_free((void*)tbind, T_BIND);
 error1:
  return 1;
}
